QuantLib: MCLongstaffSchwartzEngine< GenericEngine, MC, RNG, S, RNG_Calibration > Class Template Reference

A free/open-source library for quantitative finance Reference manual - version 1.12

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MCLongstaffSchwartzEngine< GenericEngine, MC, RNG, S, RNG_Calibration > Class Template Referenceabstract

Longstaff-Schwarz Monte Carlo engine for early exercise options. More...

`#include <ql/pricingengines/mclongstaffschwartzengine.hpp>`

Inheritance diagram for MCLongstaffSchwartzEngine< GenericEngine, MC, RNG, S, RNG_Calibration >:
[legend]

## Public Types
typedef MC< RNG >::path_type | path_type
typedef McSimulation< MC, RNG, S >::stats_type | stats_type
typedef McSimulation< MC, RNG, S >::path_pricer_type | path_pricer_type
typedef McSimulation< MC, RNG, S >::path_generator_type | path_generator_type
typedef McSimulation< MC, RNG_Calibration, S >::path_generator_type | path_generator_type_calibration
Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Public Types inherited from McSimulation< MC, RNG, S >
typedef MonteCarloModel< MC, RNG, S >::path_generator_type | path_generator_type
typedef MonteCarloModel< MC, RNG, S >::path_pricer_type | path_pricer_type
typedef MonteCarloModel< MC, RNG, S >::stats_type | stats_type
typedef MonteCarloModel< MC, RNG, S >::result_type | result_type

## Public Member Functions
| MCLongstaffSchwartzEngine (const boost::shared_ptr< StochasticProcess > &process, Size timeSteps, Size timeStepsPerYear, bool brownianBridge, bool antitheticVariate, bool controlVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed, Size nCalibrationSamples=Null< Size >(), boost::optional< bool > brownianBridgeCalibration=boost::none, boost::optional< bool > antitheticVariateCalibration=boost::none, BigNatural seedCalibration=Null< Size >())
void | calculate () const
Public Member Functions inherited from GenericEngine< ArgumentsType, ResultsType >
PricingEngine::arguments * | getArguments () const
const PricingEngine::results * | getResults () const
void | reset ()
void | update ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from McSimulation< MC, RNG, S >
result_type | value (Real tolerance, Size maxSamples=QL_MAX_INTEGER, Size minSamples=1023) const
| add samples until the required absolute tolerance is reached
result_type | valueWithSamples (Size samples) const
| simulate a fixed number of samples
result_type | errorEstimate () const
| error estimated using the samples simulated so far
const stats_type & | sampleAccumulator (void) const
| access to the sample accumulator for richer statistics
void | calculate (Real requiredTolerance, Size requiredSamples, Size maxSamples) const
| basic calculate method provided to inherited pricing engines

## Protected Member Functions
virtual boost::shared_ptr< LongstaffSchwartzPathPricer< path_type > > | lsmPathPricer () const =0
TimeGrid | timeGrid () const
boost::shared_ptr< path_pricer_type > | pathPricer () const
boost::shared_ptr< path_generator_type > | pathGenerator () const
Protected Member Functions inherited from McSimulation< MC, RNG, S >
| McSimulation (bool antitheticVariate, bool controlVariate)
virtual boost::shared_ptr< path_pricer_type > | controlPathPricer () const
virtual boost::shared_ptr< path_generator_type > | controlPathGenerator () const
virtual boost::shared_ptr< PricingEngine > | controlPricingEngine () const
virtual result_type | controlVariateValue () const

## Protected Attributes
boost::shared_ptr< StochasticProcess > | process_
const Size | timeSteps_
const Size | timeStepsPerYear_
const bool | brownianBridge_
const Size | requiredSamples_
const Real | requiredTolerance_
const Size | maxSamples_
const BigNatural | seed_
const Size | nCalibrationSamples_
const bool | brownianBridgeCalibration_
const bool | antitheticVariateCalibration_
const BigNatural | seedCalibration_
boost::shared_ptr< LongstaffSchwartzPathPricer< path_type > > | pathPricer_
boost::shared_ptr< MonteCarloModel< MC, RNG_Calibration, S > > | mcModelCalibration_
Protected Attributes inherited from GenericEngine< ArgumentsType, ResultsType >
ArgumentsType | arguments_
ResultsType | results_
Protected Attributes inherited from McSimulation< MC, RNG, S >
boost::shared_ptr< MonteCarloModel< MC, RNG, S > > | mcModel_
bool | antitheticVariate_
bool | controlVariate_

## Additional Inherited Members
Static Protected Member Functions inherited from McSimulation< MC, RNG, S >
template<class Sequence >
static Real | maxError (const Sequence &sequence)
static Real | maxError (Real error)

## Detailed Description

### template<class GenericEngine, template< class > class MC, class RNG, class S = Statistics, class RNG_Calibration = RNG>
class QuantLib::MCLongstaffSchwartzEngine< GenericEngine, MC, RNG, S, RNG_Calibration >

Longstaff-Schwarz Monte Carlo engine for early exercise options.

References:

Francis Longstaff, Eduardo Schwartz, 2001. Valuing American Options by Simulation: A Simple Least-Squares Approach, The Review of Financial Studies, Volume 14, No. 1, 113-147

Tests:
  the correctness of the returned value is tested by reproducing results available in web/literature

## Constructor & Destructor Documentation

## ◆ MCLongstaffSchwartzEngine()

MCLongstaffSchwartzEngine | ( | const boost::shared_ptr< StochasticProcess > & | process,
|  | Size | timeSteps,
|  | Size | timeStepsPerYear,
|  | bool | brownianBridge,
|  | bool | antitheticVariate,
|  | bool | controlVariate,
|  | Size | requiredSamples,
|  | Real | requiredTolerance,
|  | Size | maxSamples,
|  | BigNatural | seed,
|  | Size | nCalibrationSamples = `Null<Size>()`,
|  | boost::optional< bool > | brownianBridgeCalibration = `boost::none`,
|  | boost::optional< bool > | antitheticVariateCalibration = `boost::none`,
|  | BigNatural | seedCalibration = `Null<Size>()`
| ) |  |

If the parameters brownianBridge and antitheticVariate are not given they are chosen to be identical to the respective parameters for pricing; the seed for calibration is chosen to be zero if the pricing seed is zero and otherwise as the pricing seed plus some offset to avoid identical paths in calibration and pricing; note however that this has no effect for low discrepancy RNGs usually, it is therefore recommended to use pseudo random generators for the calibration phase always (and possibly quasi monte carlo in the subsequent pricing).